import com.danitheskunk.skunkworks.*;
import com.danitheskunk.skunkworks.gfx.Color;

public class Test {
	public static void main(String[] args) {
		/*
		var windows = Window.getAllVisible();

		System.out.printf("%d Open Windows:\n", windows.size());
		for(var window: windows) {
			System.out.printf("%s -- %s -- %s\n", window.getTitle(), window.getClassName(), window.getExecutableName());
		}
		windows.get(0).setBorder(true);
		windows.get(0).setBorderRounded(false);
		windows.get(0).move(new Recti(1280, 720, 2560, 1440));
		windows.get(0).debugPrintStyles();
		windows.get(0).debugPrintStylesEx();
		Window.onKey();
		Window.onNewWindow();
		Window.messageLoop();
		*/

		var engine = new Engine();
		var window = engine.openWindow(new Vec2i(1280, 720), "Skunkworks");
		var img = engine.loadImage("C:\\Users\\dani\\Videos\\Screenshot 2022-06-25 17-00-59.png");
		var tex2 = window.loadTexture("C:\\art\\pixel stuff.png");
		var tileset = window.loadTextureArray("C:\\stream\\coding\\rlc\\tilemap.png", new Vec2i(16, 16));
		var font = window.loadFontTileset("EGA8x14.png");
		var font2 = window.loadFontTTF("fonts\\LiberationSans-Regular.ttf", 16*8.f);
		var font3 = window.loadFontTTF("fonts\\LiberationSans-Regular.ttf", 16);
		var tex = window.loadTexture(img);
		var slice = window.loadNineSlice("demoassets\\9slice-2.png");
		//window.setDebug(true);

		while(!window.shouldClose()) {
			window.tick();
			var renderContext = window.renderStart();
			renderContext.drawTextureRectangle(
				new Recti(0, 0, 1280, 720),
				tex,
				false
			);
			//renderContext.drawTextureRectangle(
			//	new Recti(new Vec2i(200, 100), tex2.getSize()),
			//	tex2,
			//	true
			//);

			renderContext.drawTextureRectangle(
				new Recti(new Vec2i(400, 400), new Vec2i(160, 160)),
				tileset.get(0x30),
				true
			);

			renderContext.drawString(new Vec2i(710, 140), "hello world mew", font2);


			renderContext.drawNineSlice(slice, new Recti(100, 100, 75, 23));
			//renderContext.drawString(new Vec2i(118, 117), "Meow", font3, new Color(0,0,0));
			renderContext.drawString(new Vec2i(122, 105), "Meow", font, new Color(0,0,0));
			window.renderFinish(renderContext);
		}

	}
}
